#pragma once

class CSettingTypeRomDatabase :
    public CSettingType
{
public:
    CSettingTypeRomDatabase(const char * Name, const char * DefaultValue );
    CSettingTypeRomDatabase(const char * Name, bool DefaultValue );
    CSettingTypeRomDatabase(const char * Name, int DefaultValue );
    CSettingTypeRomDatabase(const char * Name, SettingID DefaultSetting );
    ~CSettingTypeRomDatabase();

    virtual SettingLocation GetSettingsLocation ( void ) const { return SettingLocation_RomDatabase; }

    //return the values
    virtual bool Load ( int Index, bool & Value   ) const;
    virtual bool Load ( int Index, uint32_t & Value  ) const;
    virtual bool Load ( int Index, stdstr & Value ) const;

    //Update the settings
    virtual void Save ( int Index, bool Value );
    virtual void Save ( int Index, uint32_t Value );
    virtual void Save ( int Index, const stdstr & Value );
    virtual void Save ( int Index, const char * Value );

    static void Initilize ( void );

private:
    CSettingTypeRomDatabase(void);                                               // Disable default constructor
    CSettingTypeRomDatabase(const CSettingTypeRomDatabase&);              // Disable copy constructor
    CSettingTypeRomDatabase& operator=(const CSettingTypeRomDatabase&);   // Disable assignment

    const const char * m_KeyName;
    const const char * m_DefaultStr;
    const int          m_DefaultValue;
    const SettingID    m_DefaultSetting;

    static CIniFile *  m_SettingsIniFile;
    static bool        m_UseRegistry;
    stdstr             m_SectionIdent;
};
